/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * File Name          : app_freertos.c
  * Description        : Code for freertos applications
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "main.h"
#include "cmsis_os.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN Variables */
uint8_t ui8TimPulseRed = 0;   // TODO: delete
uint8_t ui8TimPulseGreen = 0; // TODO: delete
uint8_t ui8TimPulseBlue = 0;  // TODO: delete
/* USER CODE END Variables */
/* Definitions for defaultTask */
osThreadId_t defaultTaskHandle;
const osThreadAttr_t defaultTask_attributes = {
  .name = "defaultTask",
  .priority = (osPriority_t) osPriorityNormal,
  .stack_size = 128 * 4
};

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN FunctionPrototypes */

/* USER CODE END FunctionPrototypes */

void StartDefaultTask(void *argument);

void MX_FREERTOS_Init(void); /* (MISRA C 2004 rule 8.1) */

/**
  * @brief  FreeRTOS initialization
  * @param  None
  * @retval None
  */
void MX_FREERTOS_Init(void) {
  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* USER CODE BEGIN RTOS_MUTEX */
    /* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
    /* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
    /* start timers, add new ones, ... */
  /* USER CODE END RTOS_TIMERS */

  /* USER CODE BEGIN RTOS_QUEUES */
    /* add queues, ... */
  /* USER CODE END RTOS_QUEUES */

  /* Create the thread(s) */
  /* creation of defaultTask */
  defaultTaskHandle = osThreadNew(StartDefaultTask, NULL, &defaultTask_attributes);

  /* USER CODE BEGIN RTOS_THREADS */
    /* add threads, ... */
  /* USER CODE END RTOS_THREADS */

  /* USER CODE BEGIN RTOS_EVENTS */
    /* add events, ... */
  /* USER CODE END RTOS_EVENTS */

}

/* USER CODE BEGIN Header_StartDefaultTask */
/**
  * @brief  Function implementing the defaultTask thread.
  * @param  argument: Not used
  * @retval None
  */





uint32_t dbgcCounter = 0;


//etl::string<8> dbgText;
/* USER CODE END Header_StartDefaultTask */
void StartDefaultTask(void *argument)
{
  /* USER CODE BEGIN StartDefaultTask */
    /* Infinite loop */
    for (;;)
    {
        dbgcCounter++;
        HAL_GPIO_WritePin(Dbg0_GPIO_Port, Dbg0_Pin, GPIO_PIN_SET);
        //ITM_Write("SWO\r\n");
        //etl::to_string(dbgcCounter, dbgText, false);
        //ITM_Write(dbgText);
        //ITM_Write("\r\n");
        HAL_GPIO_WritePin(Dbg0_GPIO_Port, Dbg0_Pin, GPIO_PIN_RESET);

        //HAL_GPIO_WritePin(Dbg0_GPIO_Port, Dbg0_Pin, GPIO_PIN_SET);
        printf("Sem %d\r\n", dbgcCounter);
        //HAL_GPIO_WritePin(Dbg0_GPIO_Port, Dbg0_Pin, GPIO_PIN_RESET);

        HAL_GPIO_TogglePin(LedCan1_GPIO_Port, LedCan1_Pin);
        HAL_Delay(500);
#if 0
      //ITM_SendChar('T');
      //printf("\n\r welcome to www.waveshere.com !!!\n\r");
      HAL_GPIO_WritePin(SpiCs_GPIO_Port, SpiCs_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(SpiCs_GPIO_Port, SpiCs_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(LedCan1_GPIO_Port, LedCan1_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(LedCan2_GPIO_Port, LedCan2_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(LedCan3_GPIO_Port, LedCan3_Pin, GPIO_PIN_SET);
      ui8TimPulseRed = 0;
      ui8TimPulseGreen = 0;
      ui8TimPulseBlue = 0;
      HAL_GPIO_WritePin(LedSysBtn_GPIO_Port, LedSysBtn_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(CtrlDisp_GPIO_Port, CtrlDisp_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(RelayK1_GPIO_Port, RelayK1_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(RelayK2_GPIO_Port, RelayK2_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(DcDc_GPIO_Port, DcDc_Pin, GPIO_PIN_SET);
      HAL_GPIO_WritePin(Fan_GPIO_Port, Fan_Pin, GPIO_PIN_SET);
      osDelay(500);

      //        // Test: Pulse SpiCs Pin
      HAL_GPIO_WritePin(SpiCs_GPIO_Port, SpiCs_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(SpiCs_GPIO_Port, SpiCs_Pin, GPIO_PIN_SET); // off
      //        osDelay(100);

      // Test: Pulse LedCan1
      HAL_GPIO_WritePin(LedCan1_GPIO_Port, LedCan1_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(LedCan1_GPIO_Port, LedCan1_Pin, GPIO_PIN_SET); // off
      osDelay(100);

      // Test: Pulse LedCan2
      HAL_GPIO_WritePin(LedCan2_GPIO_Port, LedCan2_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(LedCan2_GPIO_Port, LedCan2_Pin, GPIO_PIN_SET); // off
      osDelay(100);

      // Test: Pulse LedCan3
      HAL_GPIO_WritePin(LedCan3_GPIO_Port, LedCan3_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(LedCan3_GPIO_Port, LedCan3_Pin, GPIO_PIN_SET); // off
      osDelay(100);

      // Test: Pulse StatusLed red
      ui8TimPulseRed = 100;
      ui8TimPulseGreen = 0;
      ui8TimPulseBlue = 0;
      osDelay(500);
      //        ui8TimPulseRed = 0;
      //        ui8TimPulseGreen = 0;
      //        ui8TimPulseBlue = 0;
      //        osDelay(100);
      //
      // Test: Pulse StatusLed green
      ui8TimPulseRed = 0;
      ui8TimPulseGreen = 100;
      ui8TimPulseBlue = 0;
      osDelay(500);
      //        ui8TimPulseRed = 0;
      //        ui8TimPulseGreen = 0;
      //        ui8TimPulseBlue = 0;
      //        osDelay(100);
      //
      //        // Test: Pulse StatusLed blue
      ui8TimPulseRed = 0;
      ui8TimPulseGreen = 0;
      ui8TimPulseBlue = 100;
      osDelay(500);
      //        ui8TimPulseRed = 0;
      //        ui8TimPulseGreen = 0;
      //        ui8TimPulseBlue = 0;
      //        osDelay(100);
      //
      ui8TimPulseRed = 100;
      ui8TimPulseGreen = 100;
      ui8TimPulseBlue = 100;
      osDelay(500);

      //        // Test: Pulse LedSysBtn
      //        // Q403
      HAL_GPIO_WritePin(LedSysBtn_GPIO_Port, LedSysBtn_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(LedSysBtn_GPIO_Port, LedSysBtn_Pin, GPIO_PIN_SET); // off
      //        osDelay(100);
      //
      //        // Test: Pulse CtrlDisp
      //        // Q408
      HAL_GPIO_WritePin(CtrlDisp_GPIO_Port, CtrlDisp_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(CtrlDisp_GPIO_Port, CtrlDisp_Pin, GPIO_PIN_SET); // off
      //        osDelay(100);
      //
      //        // Test: Pulse RelayK1
      //        // Q402
      HAL_GPIO_WritePin(RelayK1_GPIO_Port, RelayK1_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(RelayK1_GPIO_Port, RelayK1_Pin, GPIO_PIN_SET); // off
      //        osDelay(100);
      //
      //        // Test: Pulse RelayK2
      //        // Q407
      HAL_GPIO_WritePin(RelayK2_GPIO_Port, RelayK2_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(RelayK2_GPIO_Port, RelayK2_Pin, GPIO_PIN_SET); // off
      //        osDelay(100);
      //
      //        // Test: Pulse DcDc
      //        // Q404
      HAL_GPIO_WritePin(DcDc_GPIO_Port, DcDc_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(DcDc_GPIO_Port, DcDc_Pin, GPIO_PIN_SET); // off
      //        osDelay(100);
      //
      //        // Test: Pulse Fan
      //        // Q410
      HAL_GPIO_WritePin(Fan_GPIO_Port, Fan_Pin, GPIO_PIN_RESET); // on
      osDelay(500);
      //        HAL_GPIO_WritePin(Fan_GPIO_Port, Fan_Pin, GPIO_PIN_SET); // off
      //        osDelay(100);
#endif
    }
  /* USER CODE END StartDefaultTask */
}

/* Private application code --------------------------------------------------*/
/* USER CODE BEGIN Application */

/* USER CODE END Application */

